#include "common.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

int
LLVMFuzzerTestOneInput(const uint8_t *data, size_t size) {
    size_t i = 0;

    int32_t int32_eq_const_0_0;
    uint32_t uint32_eq_const_1_0;
    uint16_t uint16_eq_const_2_0;
    int64_t int64_eq_const_3_0;
    uint8_t uint8_eq_const_4_0;
    uint8_t uint8_eq_const_5_0;
    int8_t int8_eq_const_6_0;
    uint16_t uint16_eq_const_7_0;
    uint8_t uint8_eq_const_8_0;
    int8_t int8_eq_const_9_0;
    uint64_t uint64_eq_const_10_0;
    int8_t int8_eq_const_11_0;
    uint64_t uint64_eq_const_12_0;
    int32_t int32_eq_const_13_0;
    uint64_t uint64_eq_const_14_0;
    int64_t int64_eq_const_15_0;
    int8_t int8_eq_const_16_0;
    uint8_t uint8_eq_const_17_0;
    int32_t int32_eq_const_18_0;
    uint8_t uint8_eq_const_19_0;
    int16_t int16_eq_const_20_0;
    uint32_t uint32_eq_const_21_0;
    int32_t int32_eq_const_22_0;
    int32_t int32_eq_const_23_0;
    uint32_t uint32_eq_const_24_0;
    int16_t int16_eq_const_25_0;
    int8_t int8_eq_const_26_0;
    int8_t int8_eq_const_27_0;
    uint64_t uint64_eq_const_28_0;
    uint8_t uint8_eq_const_29_0;
    uint16_t uint16_eq_const_30_0;
    int16_t int16_eq_const_31_0;

    if (size < 104)
        return TEPHRA_EXIT_FAILURE;


    memcpy(&int32_eq_const_0_0, &data[i], 4);
    i += 4;
    memcpy(&uint32_eq_const_1_0, &data[i], 4);
    i += 4;
    memcpy(&uint16_eq_const_2_0, &data[i], 2);
    i += 2;
    memcpy(&int64_eq_const_3_0, &data[i], 8);
    i += 8;
    memcpy(&uint8_eq_const_4_0, &data[i], 1);
    i += 1;
    memcpy(&uint8_eq_const_5_0, &data[i], 1);
    i += 1;
    memcpy(&int8_eq_const_6_0, &data[i], 1);
    i += 1;
    memcpy(&uint16_eq_const_7_0, &data[i], 2);
    i += 2;
    memcpy(&uint8_eq_const_8_0, &data[i], 1);
    i += 1;
    memcpy(&int8_eq_const_9_0, &data[i], 1);
    i += 1;
    memcpy(&uint64_eq_const_10_0, &data[i], 8);
    i += 8;
    memcpy(&int8_eq_const_11_0, &data[i], 1);
    i += 1;
    memcpy(&uint64_eq_const_12_0, &data[i], 8);
    i += 8;
    memcpy(&int32_eq_const_13_0, &data[i], 4);
    i += 4;
    memcpy(&uint64_eq_const_14_0, &data[i], 8);
    i += 8;
    memcpy(&int64_eq_const_15_0, &data[i], 8);
    i += 8;
    memcpy(&int8_eq_const_16_0, &data[i], 1);
    i += 1;
    memcpy(&uint8_eq_const_17_0, &data[i], 1);
    i += 1;
    memcpy(&int32_eq_const_18_0, &data[i], 4);
    i += 4;
    memcpy(&uint8_eq_const_19_0, &data[i], 1);
    i += 1;
    memcpy(&int16_eq_const_20_0, &data[i], 2);
    i += 2;
    memcpy(&uint32_eq_const_21_0, &data[i], 4);
    i += 4;
    memcpy(&int32_eq_const_22_0, &data[i], 4);
    i += 4;
    memcpy(&int32_eq_const_23_0, &data[i], 4);
    i += 4;
    memcpy(&uint32_eq_const_24_0, &data[i], 4);
    i += 4;
    memcpy(&int16_eq_const_25_0, &data[i], 2);
    i += 2;
    memcpy(&int8_eq_const_26_0, &data[i], 1);
    i += 1;
    memcpy(&int8_eq_const_27_0, &data[i], 1);
    i += 1;
    memcpy(&uint64_eq_const_28_0, &data[i], 8);
    i += 8;
    memcpy(&uint8_eq_const_29_0, &data[i], 1);
    i += 1;
    memcpy(&uint16_eq_const_30_0, &data[i], 2);
    i += 2;
    memcpy(&int16_eq_const_31_0, &data[i], 2);
    i += 2;


    if (int32_eq_const_0_0 == 1408424292)
    if (uint32_eq_const_1_0 == 2442347942)
    if (uint16_eq_const_2_0 == 40329)
    if (int64_eq_const_3_0 == -2748118536293601165)
    if (uint8_eq_const_4_0 == 112)
    if (uint8_eq_const_5_0 == 234)
    if (int8_eq_const_6_0 == -64)
    if (uint16_eq_const_7_0 == 5668)
    if (uint8_eq_const_8_0 == 66)
    if (int8_eq_const_9_0 == -81)
    if (uint64_eq_const_10_0 == 6675537870138927602u)
    if (int8_eq_const_11_0 == -68)
    if (uint64_eq_const_12_0 == 8939106122845968140u)
    if (int32_eq_const_13_0 == -1265591779)
    if (uint64_eq_const_14_0 == 15371962507058131169u)
    if (int64_eq_const_15_0 == 5858410151441704057)
    if (int8_eq_const_16_0 == 77)
    if (uint8_eq_const_17_0 == 135)
    if (int32_eq_const_18_0 == -1009794110)
    if (uint8_eq_const_19_0 == 244)
    if (int16_eq_const_20_0 == -6704)
    if (uint32_eq_const_21_0 == 1741135429)
    if (int32_eq_const_22_0 == -674980168)
    if (int32_eq_const_23_0 == 891233644)
    if (uint32_eq_const_24_0 == 2877975843)
    if (int16_eq_const_25_0 == 27496)
    if (int8_eq_const_26_0 == 88)
    if (int8_eq_const_27_0 == -102)
    if (uint64_eq_const_28_0 == 9210245196337955715u)
    if (uint8_eq_const_29_0 == 111)
    if (uint16_eq_const_30_0 == 49902)
    if (int16_eq_const_31_0 == 31747)
        BOOM();

    return TEPHRA_EXIT_SUCCESS;
}

#ifdef __cplusplus
}
#endif
